
// noconflict mode
var ff = jQuery.noConflict();

// calculate given space
ff( window ).bind("resize", function(){
    resize();
});

ff(document).ready(function(){
    resize();
});


	// resize column width
	function resize(){
	
	//get element
	var element  = ff("div[data-width]");
		element.each(function( index ) {
			
			//set width
			var size = ff(this).width();
			var minWidth = ff(this).attr("data-width");

			if (minWidth !== null &&  size !== null){
				ff(this).attr("data-column", Math.floor(size / minWidth));
			}
		}); 
	};

	const nextButton = document.getElementById("nextBtn")
	var currentTab = 0; // Current tab is set to be the first tab (0)
	showTab(currentTab); // Display the current tab

	function showTab(n) {
	  
		
	  // This function will display the specified tab of the form ...
	  var x = document.getElementsByClassName("ff-valuation-tab");
	  
	  
	  x[n].style.display = "block";
	  // ... and fix the Previous/Next buttons:
	  if (n == 0) {
		document.getElementById("prevBtn").style.display = "none";
	  } else {
		document.getElementById("prevBtn").style.display = "inline";
	  }
	  if (n == (x.length - 1)) {
			nextButton.innerHTML = "Vollständigen Report anfordern";

			var captchaEnabled = x[n].dataset.captcha;

			if ( captchaEnabled == 'true' ) {
				nextButton.disabled = true;
			}
	  } else {
		document.getElementById("nextBtn").innerHTML = "Weiter";
	  }
	  // ... and run a function that displays the correct step indicator:
	  fixStepIndicator(n);
	}

	function nextPrev(n) {
	  // This function will figure out which tab to display
	  var x = document.getElementsByClassName("ff-valuation-tab");
	  var u = document.getElementsByClassName("ff-valuation-button");
	  var z = document.getElementsByClassName("ff-valuation-loading");
	  var i = document.getElementsByClassName("ff-requiert-label");
	
	  // Exit the function if any field in the current tab is invalid:
	  if (n == 1 && !validateForm()) {
		return false;
	  }	
	  // Hide the current tab:
	  x[currentTab].style.display = "none";

	  // Increase or decrease the current tab by 1:
	  currentTab = currentTab + n;
	  // if you have reached the end of the form... :
	  if (currentTab >= x.length) {
		//...the form gets submitted:
		u[0].style.display = "none";
		i[0].style.display = "none";
		z[0].style.display = "flex";
		document.getElementById("regForm").submit();
	  }
	  // Otherwise, display the correct tab:
	  showTab(currentTab);
	}

	function validateForm() {
	  // This function deals with validation of the form fields
	  var x, y, i, valid = "valid";
	  x = document.getElementsByClassName("ff-valuation-tab");
	  y = x[currentTab].getElementsByTagName("input");
	  // A loop that checks every input field in the current tab:
	  for (i = 0; i < y.length; i++) {
		// If a field is empty...
		
			if (  y[i].hasAttribute('required') ) 
			{
				if ((y[i].value != "" && y[i].value <= y[i].max && y[i].value >= y[i].min) && y[i].type != "checkbox" ) {
				  // add an "invalid" class to the field:
				  y[i].className = " valid";

				}
				else if (y[i].value != "" && y[i].max == "" && y[i].min == "" && y[i].type != "checkbox") {
				  // add an "invalid" class to the field:
				  y[i].className = " valid";

				}
				else if (y[i].checked == true  && y[i].type == "checkbox") 
				{
				  // add an "invalid" class to the field:
				  y[i].className = " valid";

				}
				else
				{
				  // add an "invalid" class to the field:
				  y[i].className = "invalid";
				  y[i].parentNode.id = "invalid";
				  // and set the current valid status to false:
				  valid = false; 	 
				}		
			}
	  }
	  // If the valid status is true, mark the step as finished and valid:
	  if (valid) {
		document.getElementsByClassName("step")[currentTab].className += " finish ff-bg-primary";
	  }
	  return valid; // return the valid status
	}

	function fixStepIndicator(n) {
	  // This function removes the "active" class of all steps...
	  var i, x = document.getElementsByClassName("step");
	  for (i = 0; i < x.length; i++) {
		x[i].className = x[i].className.replace(" active", "");
	  }
	  //... and adds the "active" class to the current step:
	  x[n].className += " active";
	}


	// Captcha functions for Contact tab
	var code;
	function createCaptcha() {
		//clear the contents of captcha div first 
		document.getElementById('captcha').innerHTML = "";
		const charsStr =
		"0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ@!#$%^&*";
		var lengthOtp = 6;
		var captcha = [];
		for (var i = 0; i < lengthOtp; i++) {
			//below code will not allow Repetition of Characters
			var index = Math.floor(Math.random() * charsStr.length + 1); //get the next character from the array
			if (captcha.indexOf(charsStr[index]) == -1) {
				captcha.push(charsStr[index]);
			}	else {
				i--;
			}
		}
		var canv = document.createElement("canvas");
		canv.id = "captcha";
		canv.width = 110;
		canv.height = 50;
		var ctx = canv.getContext("2d");
		ctx.font = "25px Georgia";
		ctx.strokeText(captcha.join(""), 0, 30);
		//storing captcha so that can validate you can save it somewhere else according to your specific requirements
		code = captcha.join("");
		document.getElementById("captcha").appendChild(canv); // adds the canvas to the body element
	}

	createCaptcha();

	function validateCaptcha() {
		event.preventDefault();
		if (document.getElementById("cpatchaTextBox").value == code) {
			nextButton.style.backgroundColor="#4CAF50"
			nextButton.style.color="#fff"
			nextButton.disabled = false;
		} else {
			document.getElementById("cpatchaTextBox").value = ""
			document.getElementById("cpatchaTextBox").placeholder = "Ungültiges Captcha.";
		}
	}

	(function ($) {
	$.fn.countTo = function (options) {
		options = options || {};
		
		return $(this).each(function () {
			// set options for current element
			var settings = $.extend({}, $.fn.countTo.defaults, {
				from:            $(this).data('from'),
				to:              $(this).data('to'),
				speed:           $(this).data('speed'),
				refreshInterval: $(this).data('refresh-interval'),
				decimals:        $(this).data('decimals')
			}, options);
			
			// how many times to update the value, and how much to increment the value on each update
			var loops = Math.ceil(settings.speed / settings.refreshInterval),
				increment = (settings.to - settings.from) / loops;
			
			// references & variables that will change with each update
			var self = this,
				$self = $(this),
				loopCount = 0,
				value = settings.from,
				data = $self.data('countTo') || {};
			
			$self.data('countTo', data);
			
			// if an existing interval can be found, clear it first
			if (data.interval) {
				clearInterval(data.interval);
			}
			data.interval = setInterval(updateTimer, settings.refreshInterval);
			
			// initialize the element with the starting value
			render(value);
			
			function updateTimer() {
				value += increment;
				loopCount++;
				
				render(value);
				
				if (typeof(settings.onUpdate) == 'function') {
					settings.onUpdate.call(self, value);
				}
				
				if (loopCount >= loops) {
					// remove the interval
					$self.removeData('countTo');
					clearInterval(data.interval);
					value = settings.to;
					
					if (typeof(settings.onComplete) == 'function') {
						settings.onComplete.call(self, value);
					}
				}
			}
			
			function render(value) {
				var formattedValue = settings.formatter.call(self, value, settings);
				$self.html(formattedValue);
			}
		});
	};
	
	$.fn.countTo.defaults = {
		from: 0,               // the number the element should start at
		to: 0,                 // the number the element should end at
		speed: 1000,           // how long it should take to count between the target numbers
		refreshInterval: 100,  // how often the element should be updated
		decimals: 0,           // the number of decimal places to show
		formatter: formatter,  // handler for formatting the value before rendering
		onUpdate: null,        // callback method for every time the element is updated
		onComplete: null       // callback method for when the element finishes updating
	};
	
	function formatter(value, settings) {
		return value.toFixed(settings.decimals);
	}
}(ff));

ff(function ($) {
  // custom formatting example
  $('.count-number').data('countToOptions', {
	formatter: function (value, options) {
	  return value.toFixed(options.decimals).replace(/\B(?=(?:\d{3})+(?!\d))/g, ',');
	}
  });
  
  // start all the timers
  $('.timer').each(count);  
  
  function count(options) {
	var $this = $(this);
	options = $.extend({}, options || {}, $this.data('countToOptions') || {});
	$this.countTo(options);
  }
});